<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <title>Test Results</title>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
    integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
  <link href="https://fonts.googleapis.com/css?family=Crimson+Text:400,700&display=swap" rel="stylesheet">
  <link rel="stylesheet" href="css/styling.min.css" />
</head>

<body>
  <h1>Test Results</h1>
  <div class="content">
    <img class="header-icon" src="assets/test-results.svg" />
    <p>
      To gain a better understanding of the strength and weaknesses of the algorithms, I conducted the following
      experiments. I simulated each combination of algorithms for Tic Tac Toe, as well as Connect Four for 100 games.
    </p>
    <p>
      My key finding are:
      <ul>
        <li>The minimax and alpha-beta pruning method reliably win against the random or genetic minimax method. This is
          true for Tic Tac Toe, as well as Connect Four.</li>
        <li>The alpha-beta pruning method performs needs significantly less time to come up with the next optimal move.
        </li>
        <li>The minimax and alpha-beta pruning method take more time that should be considered reasonable for two-player
          games.</li>
        <li>For more complex games, the genetic minimax methods can provide a near-optimal solution in a considerable
          amount of time.</li>
      </ul>
    </p>
    <div class="boards">
      <h2>Boards</h2>
      <div class="card-wrapper">
        <div class="card" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Tic Tac Toe</h5>
            <p class="card-text">A board with 3x3 fields, where any player can access every empty field at any time. The
              game is won by the player who has three connected fields vertically, horizontally or diagonally.</p>
          </div>
        </div>
        <div class="card" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Connect Four</h5>
            <p class="card-text">A board with 7x6 fields, where players can only access fields if the field below is
              already occupied by any other player (this excludes the first row). The game is won by the player who has
              four connected fields vertically, horizontally or diagonally.</p>
          </div>
        </div>
      </div>
    </div>
    <div class="algorithms">
      <h2>Algorithms</h2>
      <div class="card-wrapper">
        <div class="card" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Random</h5>
            <p class="card-text">This algorithm simply picks a random, accessible field.</p>
          </div>
        </div>
        <div class="card" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Minimax</h5>
            <p class="card-text">The minimax method utilises a score that one player tries to minimise while the other
              aims to maximise it. If a player uses the minimax method, it looks at the next n moves and all possible
              game
              states S after each move. It assumes that the opponent tries to minimise the score and then makes the move
              that should result in the overall highest score after all n moves. <br /><br />
              For Tic Tac Toe the number of next
              moves
              is the number of available fields. For Connect Four, the number of next moves is limited to a maximum of
              three. Due to the broad set of possibilities to evaluate this algorithm may take a long time.</p>
          </div>
        </div>
        <div class="card" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Alpha Beta Pruning</h5>
            <p class="card-text">This algorithm is an optimisation of the minimax method. Rather than looking at all
              possible game states the algorithm ignores certain game states, that have no chances of being selected.
              This
              is done by keeping track of already visited nodes (possible moves).<br /><br /> Even though this method
              does not
              evaluate as many game states as the minimax method, it may still take a long time to process.
            </p>
          </div>
        </div>
        <div class="card" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Genetic Minimax</h5>
            <p class="card-text">In games, time is usually a constraining factor that might not allow for the use of the
              minimax or alpha-beta pruning algorithm. For complex problems with a large set of possible solutions, it
              is
              sometimes better to make random decisions instead of evaluating all possible nodes. Genetic (or
              evolutionary) algorithms make use of that. They start with a random set of solutions and evolve this
              population over n generations. <br /><br />The genetic minimax method does that and evaluates the
              population using the
              central concept of the minimax algorithm. While it may not always find the best solution, it may find a
              near
              best solution in a shorter period.</p>
          </div>
        </div>
      </div>
    </div>
    <div class="results">
      <h2>Test Results</h2>
      <p>All test were run over 100 games on a ***</p>
      <div class="result-table">
        <h3>Tic Tac Toe - Random</h3>
        <table class="table">
          <thead>
            <tr>
              <th scope="col">A / B</th>
              <th scope="col">Wins by A</th>
              <th scope="col">Wins by B</th>
              <th scope="col">Ties</th>
              <th scope="col">Avg Time per Move A</th>
              <th scope="col">Avg Time per Move B</th>
            </tr>
          </thead>
          <tbody>
            <tr>
              <th scope="row">Random</th>
              <td>47</td>
              <td>39</td>
              <td>14</td>
              <td>0</td>
              <td>0</td>
            </tr>
            <tr>
              <th scope="row">Minimax</th>
              <td>0</td>
              <td>83</td>
              <td>17</td>
              <td>0</td>
              <td>1.3</td>
            </tr>
            <tr>
              <th scope="row">Alpha Beta Pruning</th>
              <td>0</td>
              <td>81</td>
              <td>19</td>
              <td>0</td>
              <td>0,001</td>
            </tr>
            <tr>
              <th scope="row">Genetic Minimax</th>
              <td>15</td>
              <td>82</td>
              <td>3</td>
              <td>0</td>
              <td>7</td>
            </tr>
          </tbody>
        </table>
      </div>

      <div class="result-table">
        <h3>Tic Tac Toe - Minimax</h3>
        <table class="table">
          <thead>
            <tr>
              <th scope="col">A / B</th>
              <th scope="col">Wins by A</th>
              <th scope="col">Wins by B</th>
              <th scope="col">Ties</th>
              <th scope="col">Avg Time per Move A</th>
              <th scope="col">Avg Time per Move B</th>
            </tr>
          </thead>
          <tbody>
            <tr>
              <th scope="row">Random</th>
              <td>47</td>
              <td>39</td>
              <td>14</td>
              <td>0</td>
              <td>0</td>
            </tr>
            <tr>
              <th scope="row">Minimax</th>
              <td>0</td>
              <td>83</td>
              <td>17</td>
              <td>0</td>
              <td>1.3</td>
            </tr>
            <tr>
              <th scope="row">Alpha Beta Pruning</th>
              <td>0</td>
              <td>81</td>
              <td>19</td>
              <td>0</td>
              <td>0,001</td>
            </tr>
            <tr>
              <th scope="row">Genetic Minimax</th>
              <td>15</td>
              <td>82</td>
              <td>3</td>
              <td>0</td>
              <td>7</td>
            </tr>
          </tbody>
        </table>
      </div>

      <div class="result-table">
        <h3>Tic Tac Toe - Alpha Beta Pruning</h3>
        <table class="table">
          <thead>
            <tr>
              <th scope="col">A / B</th>
              <th scope="col">Wins by A</th>
              <th scope="col">Wins by B</th>
              <th scope="col">Ties</th>
              <th scope="col">Avg Time per Move A</th>
              <th scope="col">Avg Time per Move B</th>
            </tr>
          </thead>
          <tbody>
            <tr>
              <th scope="row">Random</th>
              <td>47</td>
              <td>39</td>
              <td>14</td>
              <td>0</td>
              <td>0</td>
            </tr>
            <tr>
              <th scope="row">Minimax</th>
              <td>0</td>
              <td>83</td>
              <td>17</td>
              <td>0</td>
              <td>1.3</td>
            </tr>
            <tr>
              <th scope="row">Alpha Beta Pruning</th>
              <td>0</td>
              <td>81</td>
              <td>19</td>
              <td>0</td>
              <td>0,001</td>
            </tr>
            <tr>
              <th scope="row">Genetic Minimax</th>
              <td>15</td>
              <td>82</td>
              <td>3</td>
              <td>0</td>
              <td>7</td>
            </tr>
          </tbody>
        </table>
      </div>

      <div class="result-table">
        <h3>Tic Tac Toe - Genetic Minimax</h3>
        <table class="table">
          <thead>
            <tr>
              <th scope="col">A / B</th>
              <th scope="col">Wins by A</th>
              <th scope="col">Wins by B</th>
              <th scope="col">Ties</th>
              <th scope="col">Avg Time per Move A</th>
              <th scope="col">Avg Time per Move B</th>
            </tr>
          </thead>
          <tbody>
            <tr>
              <th scope="row">Random</th>
              <td>47</td>
              <td>39</td>
              <td>14</td>
              <td>0</td>
              <td>0</td>
            </tr>
            <tr>
              <th scope="row">Minimax</th>
              <td>0</td>
              <td>83</td>
              <td>17</td>
              <td>0</td>
              <td>1.3</td>
            </tr>
            <tr>
              <th scope="row">Alpha Beta Pruning</th>
              <td>0</td>
              <td>81</td>
              <td>19</td>
              <td>0</td>
              <td>0,001</td>
            </tr>
            <tr>
              <th scope="row">Genetic Minimax</th>
              <td>15</td>
              <td>82</td>
              <td>3</td>
              <td>0</td>
              <td>7</td>
            </tr>
          </tbody>
        </table>
      </div>
      <hr />
      <p>Some quick example text to build on the card title and make up the bulk of the card's content.</p>
      <div class="result-table">
        <h3>Connect Four - Random</h3>
        <table class="table">
          <thead>
            <tr>
              <th scope="col">A / B</th>
              <th scope="col">Wins by A</th>
              <th scope="col">Wins by B</th>
              <th scope="col">Ties</th>
              <th scope="col">Avg Time per Move A</th>
              <th scope="col">Avg Time per Move B</th>
            </tr>
          </thead>
          <tbody>
            <tr>
              <th scope="row">Random</th>
              <td>47</td>
              <td>39</td>
              <td>14</td>
              <td>0</td>
              <td>0</td>
            </tr>
            <tr>
              <th scope="row">Minimax</th>
              <td>0</td>
              <td>83</td>
              <td>17</td>
              <td>0</td>
              <td>1.3</td>
            </tr>
            <tr>
              <th scope="row">Alpha Beta Pruning</th>
              <td>0</td>
              <td>81</td>
              <td>19</td>
              <td>0</td>
              <td>0,001</td>
            </tr>
            <tr>
              <th scope="row">Genetic Minimax</th>
              <td>15</td>
              <td>82</td>
              <td>3</td>
              <td>0</td>
              <td>7</td>
            </tr>
          </tbody>
        </table>
      </div>

      <div class="result-table">
        <h3>Connect Four - Minimax</h3>
        <table class="table">
          <thead>
            <tr>
              <th scope="col">A / B</th>
              <th scope="col">Wins by A</th>
              <th scope="col">Wins by B</th>
              <th scope="col">Ties</th>
              <th scope="col">Avg Time per Move A</th>
              <th scope="col">Avg Time per Move B</th>
            </tr>
          </thead>
          <tbody>
            <tr>
              <th scope="row">Random</th>
              <td>47</td>
              <td>39</td>
              <td>14</td>
              <td>0</td>
              <td>0</td>
            </tr>
            <tr>
              <th scope="row">Minimax</th>
              <td>0</td>
              <td>83</td>
              <td>17</td>
              <td>0</td>
              <td>1.3</td>
            </tr>
            <tr>
              <th scope="row">Alpha Beta Pruning</th>
              <td>0</td>
              <td>81</td>
              <td>19</td>
              <td>0</td>
              <td>0,001</td>
            </tr>
            <tr>
              <th scope="row">Genetic Minimax</th>
              <td>15</td>
              <td>82</td>
              <td>3</td>
              <td>0</td>
              <td>7</td>
            </tr>
          </tbody>
        </table>
      </div>

      <div class="result-table">
        <h3>Connect Four - Alpha Beta Pruning</h3>
        <table class="table">
          <thead>
            <tr>
              <th scope="col">A / B</th>
              <th scope="col">Wins by A</th>
              <th scope="col">Wins by B</th>
              <th scope="col">Ties</th>
              <th scope="col">Avg Time per Move A</th>
              <th scope="col">Avg Time per Move B</th>
            </tr>
          </thead>
          <tbody>
            <tr>
              <th scope="row">Random</th>
              <td>47</td>
              <td>39</td>
              <td>14</td>
              <td>0</td>
              <td>0</td>
            </tr>
            <tr>
              <th scope="row">Minimax</th>
              <td>0</td>
              <td>83</td>
              <td>17</td>
              <td>0</td>
              <td>1.3</td>
            </tr>
            <tr>
              <th scope="row">Alpha Beta Pruning</th>
              <td>0</td>
              <td>81</td>
              <td>19</td>
              <td>0</td>
              <td>0,001</td>
            </tr>
            <tr>
              <th scope="row">Genetic Minimax</th>
              <td>15</td>
              <td>82</td>
              <td>3</td>
              <td>0</td>
              <td>7</td>
            </tr>
          </tbody>
        </table>
      </div>

      <div class="result-table">
        <h3>Connect Four - Genetic Minimax</h3>
        <table class="table">
          <thead>
            <tr>
              <th scope="col">A / B</th>
              <th scope="col">Wins by A</th>
              <th scope="col">Wins by B</th>
              <th scope="col">Ties</th>
              <th scope="col">Avg Time per Move A</th>
              <th scope="col">Avg Time per Move B</th>
            </tr>
          </thead>
          <tbody>
            <tr>
              <th scope="row">Random</th>
              <td>47</td>
              <td>39</td>
              <td>14</td>
              <td>0</td>
              <td>0</td>
            </tr>
            <tr>
              <th scope="row">Minimax</th>
              <td>0</td>
              <td>83</td>
              <td>17</td>
              <td>0</td>
              <td>1.3</td>
            </tr>
            <tr>
              <th scope="row">Alpha Beta Pruning</th>
              <td>0</td>
              <td>81</td>
              <td>19</td>
              <td>0</td>
              <td>0,001</td>
            </tr>
            <tr>
              <th scope="row">Genetic Minimax</th>
              <td>15</td>
              <td>82</td>
              <td>3</td>
              <td>0</td>
              <td>7</td>
            </tr>
          </tbody>
        </table>
      </div>

    </div>
</body>

</html>